=begin
scaleGroupFloat_dj Ver 1.2: Scale and move w/ read out
Copyright 2012, June 4
DukeJazz: by James Cochran

Info:
Sketchup scale tool resizes to model units.
scaleGroupFloat tool resizes to a "group object units." 

Scale:
Group Float Scaling tool scale objects, along XYZ axes.
Drop down menu's for quick and easy use of X, Y, Z, XYZ

Ratio factor multiplier:
Group  object units range 1.0e-16 to 10e+16 m by ruby float 
Object factor unit multiplier 1.0e-34 to 1.0e+34 m

Bounding size values:
Enter values of red, green, and blue size of a group object
Value of a group bound field of  a object. Example = 9902.18921080857 *1.0_m = [magnitude of length] * [multiplier] of an [Unit]
7.38896026611329 *1.0e-005_in, this how its reads, 7.38896026611329 hundred thousandth of an inch
1.8336641508 *1000.0_mm, this how its reads, 1.8336641508 thousand units of an milimeter =1.8336641508 meters
1.0 *1.0_m, this how its reads, one unit of a meter,
By keeping unit of model same as the object, then the you don't need to say the [*multiplier].

Units: ["thou|in|ft|cubit|yd|rod|furlong|mi|Ym|Zm|Em|Pm|Tm|Gm|Mm|km|hm|dam|m|dm|cm|mm|um|nm|Angstrom|pm|am|fm|zm|ym|x?|quintillionth|y?|planckto"]
Imperial units and International  mectic units of lenght.

Vector center: 
You can read or change 3dpoint vector center value.
moves group object by [x.y;z]

Extended read out ["Bbox,Center,Ratio|Bbox,Center|Bbox|Center|Ratio|Dimension.c-vector|no|draw vector"]

scaleGroupFloat_dj v1.0 May 11 by DukeJazz-James Cochran BSE - Ruby script

Freely use, and abuse at your own risk. Fitness of usage is not warranty implied. 
Warning do not bomb or explode group objects below 1.0e-o4 because losts of objects can occur: use the undo to make its a group to recover. 
hint - Use the outliner as a aid tool.

Thank you, have fun.

Reference helped by Google Sketchup Ruby API
Reference helped by Sahi mashtab 4 1.08.2008
Reference postReply  Re: Given a x,y,z location to move a selected group? help!by sdmitch on Thu May 17, 2012 1:48 pm - I thank you
Reference postReply  Re: Given a [x,y,z] delete a text note. Need help? by TiG by TIG on Fri Jun 01, 2012 6:35 am - I thank you
=end

#___Initialize_____
$dj_x4 = ["1.0","1.0","1.0","ft","1.0 Lens multiplier","1.0","1.0","1.0","in","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","no","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0"]

def scale_groupFloatDj

#___sents_copy_group___ 
dj_ss = Sketchup.active_model.selection;if dj_ss.empty? then UI.messagebox ("Please Select. a goup.");return;end
dj_sents = [];dj_ss.each{|e|dj_sents.push(e)}

#___set_variables____
dj_x3 = [1.0,1.0,1.0];dj_x1=[1.0,1.0,1.0,39.37007874015748031,"1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0"];dj_center = [dj_x1[5],dj_x1[6],dj_x1[7]];dj_s1 = [1.0,1.0,1.0,1.0,1.0];dj_s2 = [1.0,1.0,1.0,1.0,1.0,1.0];dj_x = [-1,1.0,1.0]
dj_li = ["thou","in","ft","cubit","yd","rod","furlong","mi","Ym","Zm","Em","Pm","Tm","Gm","Mm","km","hm","dam","m","dm","cm","mm","um","nm","Angstrom","pm","am","fm","zm","ym","x?","quintillionth","y?","planckto"]
dj_x0 = [(1.0/1000.0),(1.0/1.0),(1.0/12),(1.0/18.0),(1.0/36),(1.0/240),(1.0/7920),(1.0/63360.0),(1.0/dj_x1[3]),(11.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3]),(1.0/dj_x1[3])]
dj_x2= [(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1000.0e-21),(1000.0e-18),(1000.0e-15),(1000.0e-12),(1000.0e-9),(1000.0e-6),(1000.0e-3),(1000.0e-0),(100.0e-0),(10.0e-0),(1.0e-0),(10.0e+0),(100.0e+0),(1000.0e+0),(1000.0e+3),(1000.0e+6),(1000.0e+7),(1000.0e+9),(1000.0e+12),(1000.0e+15),(1000.0e+18),(1000.0e+21),(1000.0e+24),(1000.0e+27),(1000.0e+30),(1000.0e+31)]

#___def bound_dj____
def bound_dj dj_x1,dj_x,dj_sents
@@dj_x1 = dj_x1;@@dj_x = dj_x;@@dj_center = []
copy_group = Sketchup.active_model.active_entities.add_group(dj_sents)
if (dj_x[0] != -1) then copy_group.transform!(Geom::Transformation.scaling([dj_x1[9],dj_x1[10],dj_x1[11]],@@dj_x[0],@@dj_x[1],@@dj_x[2]));end
#if (dj_x[0] != -1) then copy_group.transform!(Geom::Transformation.scaling([dj_x1[9],dj_x1[10],dj_x1[11]],-1*@@dj_x[0],-1*@@dj_x[1],-1*@@dj_x[2]));end
@@dj_center = (copy_group.bounds.center)
@@dj_x1[0] = (copy_group.bounds.width).to_f
@@dj_x1[1] = (copy_group.bounds.height).to_f 
@@dj_x1[2] = (copy_group.bounds.depth).to_f
copy_group.explode
@@dj_x1[4] = @@dj_x1[8] = @@dj_center
@@dj_x1[5] = @@dj_x1[9] = (((@@dj_center[0]).to_f ).to_s).to_f
@@dj_x1[6] = @@dj_x1[10] = (((@@dj_center[1]).to_f ).to_s).to_f 
@@dj_x1[7] = @@dj_x1[11] = (((@@dj_center[2]).to_f ).to_s).to_f
return dj_x1[0..11] ;end; #bound_dj

#___ Inputs_Bounds___
bound_dj dj_x1,dj_x,dj_sents

#___set unit_____
for i in 0..33;if ($dj_x4[3] == dj_li[i]) and ($dj_x4[3] != $dj_x4[8]) then $dj_x4[10] = dj_x0[i].to_s;$dj_x4[5] = (dj_x2[i]/($dj_x4[9].to_f)).to_s;$dj_x4[9] =dj_x2[i].to_s;end;end

#___Initialize_Box____
if (($dj_x4[3]) != ($dj_x4[8])) then $dj_x4[4] = ((($dj_x4[4].to_f ) * ($dj_x4[5].to_f)).to_s) + " Coefficient multiplier";end
for i in 0..2;dj_x1[i] *= $dj_x4[10].to_f;$dj_x4[i] = dj_x1[i].to_s+"*"+(($dj_x4[4].to_f).to_s)+"_"+ $dj_x4[3];$dj_x4[11+i] = (dj_x1[9+i]*$dj_x4[10].to_f).to_s+"*"+(($dj_x4[4].to_f).to_s)+"_"+$dj_x4[3];end
if $dj_x4[19] =="Long read out" then $dj_x4[18] = ["Dimension w,d,h (",$dj_x4[0],", ",$dj_x4[1],", ",$dj_x4[2]," ) "];$dj_x4[14] = ["Center x,y,z [",$dj_x4[11],", ",$dj_x4[12],", ",$dj_x4[13],"] "];else;$dj_x4[18]=$dj_x4[14]="n/a".to_s;end

#___Range limits____
if (dj_x1[0] == 0.0 or dj_x1[1] == 0.0 or dj_x1[2] == 0.0 ) then Sketchup.undo;Sketchup.undo;Sketchup.undo;UI.messagebox ("Goup to large or to small or not a 3d group object.
Hit cancel then reselect");end
$dj_x4[7] ="1.0".to_f.to_s;$dj_x4[8] = $dj_x4[3]

#____Box ____
dj_prompts = ["Quick scale xyz","Scale xyz","Quick scale r.w","Scale red.width","Quick scale g.d","Scale green.depth","Quick scale b.h","Scale blue.hight","Quick Scale Factor","Coefficient * ","Bbox Red.width  ","Bbox Green.depth","Bbox blue.hight ","Group bb-dimension r,g,b ","Unit","C-point x","C-point y","C-point z","Group c-vector x,y,z ","Extended read out"]
dj_values = [dj_s2[3],dj_s1[3],dj_s2[0],dj_s1[0],dj_s2[1],dj_s1[1],dj_s2[2],dj_s1[2],$dj_x4[7],$dj_x4[4],$dj_x4[0],$dj_x4[1],$dj_x4[2],$dj_x4[18],$dj_x4[3],$dj_x4[11],$dj_x4[12],$dj_x4[13],$dj_x4[14],$dj_x4[19]]
dj_l1 = ["thou|in|ft|cubit|yd|rod|furlong|mi|Ym|Zm|Em|Pm|Tm|Gm|Mm|km|hm|dam|m|dm|cm|mm|um|nm|Angstrom|pm|am|fm|zm|ym|x?|quintillionth|y?|planckto"]
dj_l2 = ["1.0|2.0|3.0|4.0|5.0|6.0|7.0|8.0|9.0|1.0e+1|1.0e+2|1.0e+3|1.0e+4|1.0e+5|1.0e+6|1.0e+7|1.0e+8|1.0e+9|1.0e+10|1.0e+11|1.0e+12|1.0e+13|1.0e+14|1.0e+15|scale bigger |scale smaller |1.0e-1|1.0e-2|1.0e-3|1.0e-4|1.0e-5|1.0e-6|1.0e-7|1.0e-8|1.0e-9|1.0e-10|1.0e-11|1.0e-12|1.0e-13|1.0e-14|1.0e-15|1.0|0.5|0.3333333333333333|0.25|0.2|0.16666666666666667|0.142857142857142857|0.125|0.1111111111111111"]
dj_l3 = ["Bbox,Center,SF|Bbox,Center|Bbox|Center|SF|no|Long read out|Reload 1 size values|Reload 2 size values|Reload 1 center values|Reload 2 center values|Save 1 target values|Save 2 target values|Draw vector|Draw cpoint"]
dj_lists = [dj_l2,"",dj_l2,"",dj_l2,"",dj_l2,"",dj_l2,"","","","","",dj_l1,"","","","",dj_l3]
results = inputbox dj_prompts,dj_values,dj_lists,"ScaleGroupFloat_dj"
if not results then Sketchup.undo;Sketchup.undo;return;end
  dj_s2[3],dj_s1[3],dj_s2[0],dj_s1[0],dj_s2[1],dj_s1[1],dj_s2[2],dj_s1[2],$dj_x4[7],$dj_x4[4],$dj_x4[0],$dj_x4[1],$dj_x4[2],$dj_x4[18],$dj_x4[3],$dj_x4[15],$dj_x4[16],$dj_x4[17],$dj_x4[14],$dj_x4[19] = results

#___ target values___
if ($dj_x4[19] == "Reload 1 size values") then for i in 0..2 ;$dj_x4[i] =$dj_x4[i+20];end;$dj_x4[19] = "no";end
if ($dj_x4[19] == "Reload 2 size values") then for i in 0..2 ;$dj_x4[i] =$dj_x4[i+26];end;$dj_x4[19] = "no";end
if ($dj_x4[19] == "Reload 1 center values") then for i in 0..2 ;$dj_x4[i+15] =$dj_x4[23+i];end;$dj_x4[19] = "no";end
if ($dj_x4[19] == "Reload 2 center values") then for i in 0..2 ;$dj_x4[i+15] =$dj_x4[29+i];end;$dj_x4[19] = "no";end
if ($dj_x4[19] == "Save 1 target values") then for i in 0..2 ;$dj_x4[i+20] =$dj_x4[i];$dj_x4[i+23]=$dj_x4[i+15];end;$dj_x4[19] = "no";end
if ($dj_x4[19] == "Save 2 target values") then for i in 0..2 ;$dj_x4[i+26] =$dj_x4[i];$dj_x4[i+29]=$dj_x4[i+15];end;$dj_x4[19] = "no";end

#___Initialize_Geom::Transformation____
if ($dj_x4[7].to_f != 1.0) then $dj_x4[4] = ((($dj_x4[4]).to_f) * (($dj_x4[7]).to_f)).to_s;end;dj_s1[3] *= dj_s2[3]
for i in 0..2;dj_s1[i] *= dj_s2[i];dj_x3[i]=$dj_x4[i].to_f;dj_x[i] = ((dj_s1[i]*dj_s1[3])*((dj_x3[i])/dj_x1[i]));end

#_API____Geom::move! new_transformation 
if [$dj_x4[11],$dj_x4[12],$dj_x4[13]] !=[$dj_x4[15],$dj_x4[16],$dj_x4[17]] then 
dj_x[1]=dj_x[1]=dj_x[1]=1
for i in 0..2;dj_x1[i+9]=$dj_x4[i+15].to_f.to_s.to_f/$dj_x4[10].to_f-dj_x1[i]/$dj_x4[10].to_f/2;end
copy_group = Sketchup.active_model.active_entities.add_group(dj_sents)
# Thanks sdmitch solved by sdmitch on Thu May 17, 2012 1:48 pm-group.move!
Geom::Transformation.new([dj_x1[5],dj_x1[6],dj_x1[7]]);copy_group.move!(Geom::Transformation.new([dj_x1[9],dj_x1[10],dj_x1[11]]))
copy_group.explode
return
else

#_API____Geom::Transformation.scaling_____
bound_dj(dj_x1,dj_x,dj_sents)                   
end

#__________draw vector____
if $dj_x4[19] =="Draw vector" then Sketchup.active_model.entities.add_line([0,0,0],[dj_x1[9],dj_x1[10],dj_x1[11]]);$dj_x4[19] = "no";end
#__________draw cpoint____
if $dj_x4[19] =="Draw cpoint" then Sketchup.active_model.active_entities.add_cpoint(Geom::Point3d.new(dj_x1[9],dj_x1[10],dj_x1[11]));$dj_x4[19] = "no";end


#__________draw read out 
if $dj_x4[19] =="Bbox,Center,SF" or $dj_x4[19] == "Bbox,Center" or $dj_x4[19] =="Bbox" or $dj_x4[19] == "Center" or $dj_x4[19] =="SF"
if (($dj_x4[3]) != ($dj_x4[8])) then $dj_x4[4] = ((($dj_x4[4].to_f ) * ($dj_x4[5].to_f)).to_s) + " Coefficient multiplier";end
for i in 0..2;dj_x1[i] *= $dj_x4[10].to_f*$dj_x4[4].to_f;dj_x1[5+i] *= $dj_x4[10].to_f*$dj_x4[4].to_f;end
$dj_x4[18] = ["Bbox(w,d,h) (",dj_x1[0].to_s+"_"+$dj_x4[3],", ",dj_x1[1].to_s+"_"+$dj_x4[3],", ",dj_x1[2].to_s+"_"+$dj_x4[3]," )"].to_s;$dj_x4[14]= ["Center (xyz) [",dj_x1[5].to_s+"_"+$dj_x4[3],", ",dj_x1[6].to_s+"_"+$dj_x4[3],", ",dj_x1[7].to_s+"_"+$dj_x4[3],"] "].to_s
Sketchup.active_model.active_entities.to_a.each{|e|
e.erase! if e.is_a?(Sketchup::Text) and e.point==Geom::Point3d.new(dj_x1[9], dj_x1[10], dj_x1[11])
}
# Thanks TiG solved by TIG on Fri Jun 01, 2012 6:35 am-e.erase!
end #if
if $dj_x4[19] =="Bbox,Center,SF" then Sketchup.active_model.entities.add_text $dj_x4[18].to_s+"\n"+$dj_x4[14].to_s+"\nX"+(($dj_x4[4].to_f )/($dj_x4[9].to_f)).to_s+" Scale Factor = inside vol/outside vol (SF = Space normalization = Space warp)",(Geom::Point3d.new([dj_x1[9], dj_x1[10], dj_x1[11]]));$dj_x4[19] = "no";end
if $dj_x4[19] =="Bbox,Center" then Sketchup.active_model.entities.add_text $dj_x4[18].to_s+"\n"+$dj_x4[14].to_s,(Geom::Point3d.new([dj_x1[9], dj_x1[10], dj_x1[11]]));$dj_x4[19] = "no";end
if $dj_x4[19] =="Bbox" then Sketchup.active_model.entities.add_text $dj_x4[18].to_s,(Geom::Point3d.new([dj_x1[9], dj_x1[10], dj_x1[11]]));$dj_x4[19] = "no";end
if $dj_x4[19] =="Center" then Sketchup.active_model.entities.add_text $dj_x4[14].to_s,(Geom::Point3d.new([dj_x1[9], dj_x1[10], dj_x1[11]]));$dj_x4[19] = "no";end
if $dj_x4[19] =="SF" then Sketchup.active_model.entities.add_text "X"+(($dj_x4[4].to_f )/($dj_x4[9].to_f)).to_s+" Scale Factor = inside vol/outside vol (SF = Space normalization = Space warp)",(Geom::Point3d.new([dj_x1[9], dj_x1[10], dj_x1[11]]));$dj_x4[19] = "no";end

_____Close_____
Sketchup.active_model.commit_operation

end  #def
=begin
#_____Toolbar_____
if ( not file_loaded? ("scaleGroupFloat_dj.rb") )
         dj = UI::Toolbar.new "scaleGroupFloat_dj"
         cmd = UI::Command.new("scaleGroupFloat_dj")  {scale_groupFloatDj}
         cmd.small_icon =cmd.large_icon ="scaleGroupFloat_dj.png"
         cmd.tooltip = "Group precision scaling tool"
         dj.add_item cmd
         dj.show

#_____menu_____
#add_separator_to_menu("Plugins")  
#UI.menu("Plugins").add_item("a_scaleGroupFloat_dj ") {scale_groupFloatDj}

=end

file_loaded("scaleGroupFloat_dj.rb")